



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>BZOJ 1834 网络扩容 最大流+最小费用流</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">BZOJ 1834 网络扩容 最大流+最小费用流</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-14 22:22:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>题目链接：</strong></p>
<p><a href="https://www.lydsy.com/JudgeOnline/problem.php?id=1834" rel="external nofollow noreferrer">https://www.lydsy.com/JudgeOnline/problem.php?id=1834</a></p>
<p><strong>题目大意：</strong></p>
<div>给定一张有向图，每条边都有一个容量C和一个扩容费用W。这里扩容费用是指将容量扩大1所需的费用。</div>
<div>求：&nbsp;</div>
<div>1、在不扩容的情况下，1到N的最大流；&nbsp;</div>
<div>2、将1到N的最大流增加K所需的最小扩容费用。</div>
<p><strong>思路：</strong></p>
<p>第一问直接求费用流，第二问，在第一问的残余网络上，对于每条边额外加上INF容量费用为w的边，限制最大流量为k，也就是在0-1之间连边，容量为s，费用为0,然后跑一遍最小费用流就可以了。</p>
<div>
<pre class="prettyprint linenums"> #include&lt;bits/stdc++.h&gt;<br />
 #define IOS ios::sync_with_stdio(false);//不可再使用scanf printf<br />
 #define Max(a, b) ((a) &gt; (b) ? (a) : (b))//禁用于函数，会超时<br />
 #define Min(a, b) ((a) &lt; (b) ? (a) : (b))<br />
 #define Mem(a) memset(a, 0, sizeof(a))<br />
 #define Dis(x, y, x1, y1) ((x - x1) * (x - x1) + (y - y1) * (y - y1))<br />
 #define MID(l, r) ((l) + ((r) - (l)) / 2)<br />
 #define lson ((o)&lt;&lt;1)<br />
 #define rson ((o)&lt;&lt;1|1)<br />
 #define Accepted 0<br />
 #pragma comment(linker, "/STACK:102400000,102400000")//栈外挂<br />
 using namespace std;<br />
 inline int read()<br />
 {<br />
     int x=,f=;char ch=getchar();<br />
     while (ch&lt;''||ch&gt;''){if (ch=='-') f=-;ch=getchar();}<br />
     while (ch&gt;=''&amp;&amp;ch&lt;=''){x=x*+ch-'';ch=getchar();}<br />
     return x*f;<br />
 }<br />
 typedef long long ll;<br />
 const int MOD = ;//const引用更快，宏定义也更快<br />
 const double eps = 1e-;<br />
 const double pi = acos(-);<br />
 const int INF = 0x3f3f3f3f;<br />
 const int maxn =  + ;<br />
 struct edge<br />
 {<br />
     int u, v, c, f, cost;<br />
     edge(int u, int v, int c, int f, int cost):u(u), v(v), c(c), f(f), cost(cost){}<br />
 };<br />
 vector&lt;edge&gt;e;<br />
 vector&lt;int&gt;G[maxn];<br />
 int a[maxn];//找增广路每个点的水流量<br />
 int p[maxn];//每次找增广路反向记录路径<br />
 int d[maxn];//SPFA算法的最短路<br />
 int inq[maxn];//SPFA算法是否在队列中

 void addedge(int u, int v, int c, int cost)<br />
 {<br />
     e.push_back(edge(u, v, c, , cost));<br />
     e.push_back(edge(v, u, , , -cost));<br />
     int m = e.size();<br />
     G[u].push_back(m - );<br />
     G[v].push_back(m - );<br />
 }<br />
 bool bellman(int s, int t, int&amp; flow, long long &amp; cost)<br />
 {<br />
     for(int i = ; i &lt;= t + ; i++)d[i] = INF;//Bellman算法的初始化<br />
     memset(inq, , sizeof(inq));<br />
     d[s] = ;inq[s] = ;//源点s的距离设为0，标记入队<br />
     p[s] = ;a[s] = INF;//源点流量为INF（和之前的最大流算法是一样的）

     queue&lt;int&gt;q;//Bellman算法和增广路算法同步进行，沿着最短路拓展增广路，得出的解一定是最小费用最大流<br />
     q.push(s);<br />
     while(!q.empty())<br />
     {<br />
         int u = q.front();<br />
         q.pop();<br />
         inq[u] = ;//入队列标记删除<br />
         for(int i = ; i &lt; G[u].size(); i++)<br />
         {<br />
             edge &amp; now = e[G[u][i]];<br />
             int v = now.v;<br />
             if(now.c &gt; now.f &amp;&amp; d[v] &gt; d[u] + now.cost)<br />
                 //now.c &gt; now.f表示这条路还未流满（和最大流一样）<br />
                 //d[v] &gt; d[u] + e.cost Bellman 算法中边的松弛<br />
             {<br />
                 d[v] = d[u] + now.cost;//Bellman 算法边的松弛<br />
                 p[v] = G[u][i];//反向记录边的编号<br />
                 a[v] = min(a[u], now.c - now.f);//到达v点的水量取决于边剩余的容量和u点的水量<br />
                 if(!inq[v]){q.push(v);inq[v] = ;}//Bellman 算法入队<br />
             }<br />
         }<br />
     }<br />
     if(d[t] == INF)return false;//找不到增广路<br />
     flow += a[t];//最大流的值，此函数引用flow这个值，最后可以直接求出flow<br />
     cost += (long long)d[t] * (long long)a[t];//距离乘上到达汇点的流量就是费用<br />
     for(int u = t; u != s; u = e[p[u]].u)//逆向存边<br />
     {<br />
         e[p[u]].f += a[t];//正向边加上流量<br />
         e[p[u] ^ ].f -= a[t];//反向边减去流量 （和增广路算法一样）<br />
     }<br />
     return true;<br />
 }<br />
 int MincostMaxflow(int s, int t, long long &amp; cost)<br />
 {<br />
     cost = ;<br />
     int flow = ;<br />
     while(bellman(s, t, flow, cost));//由于Bellman函数用的是引用，所以只要一直调用就可以求出flow和cost<br />
     return flow;//返回最大流，cost引用可以直接返回最小费用<br />
 }<br />
 int u[maxn], v[maxn], c[maxn], w[maxn];<br />
 int main()<br />
 {<br />
     IOS;<br />
     int n, m, k;<br />
     cin &gt;&gt; n &gt;&gt; m &gt;&gt; k;<br />
     for(int i = ; i &lt;= m; i++)cin &gt;&gt; u[i] &gt;&gt; v[i] &gt;&gt; c[i] &gt;&gt; w[i];<br />
     for(int i = ; i &lt;= m; i++)addedge(u[i], v[i], c[i], );<br />
     ll cost;<br />
     cout&lt;&lt;MincostMaxflow(, n, cost)&lt;&lt;" ";<br />
     addedge(, , k, );<br />
     addedge(n, n + , k, );<br />
     for(int i = ; i &lt;= m; i++)addedge(u[i], v[i], INF, w[i]);<br />
     MincostMaxflow(, n + , cost);<br />
     cout&lt;&lt;cost&lt;&lt;endl;<br />
     return Accepted;<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93wngq3.html">零OCR基础6行代码实现C&num;验证码识别</a>
		</li>
						<li><a href="https://www.batexi.com/a/3905mpjq.html">JAVA生成二维码图片代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq135x08.html">大家一起写mvc（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rxk0d9.html">在redis一致性hash&lpar;shard&rpar;中使用lua脚本的坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m3k7o9.html">20145208 实验四 Android开发基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q27kwl8.html">POJ 3628 Bookshelf 2（01背包）</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q276ml8.html">JS中数组对象去重</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdej1rv9.html">zip解压缩</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zvg329.html">增强学习贪心算法与Softmax算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z52x09.html">lua 的 WriteFile 和 ReadFile</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm6v1e9.html">《man男人》-linux命令五分钟系列之十五</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1w7ed9.html">sql server 查找指定字符串的位置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1ny3x9.html">shell script中的&dollar;&ast;和&dollar;&commat;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1yew39.html">Git 添加空文件夹的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kvl469.html">通过Windows常见性能计数器分析服务器性能瓶颈</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j33ro8.html">C&plus;&plus;第四篇--重载&lowbar;指针&lowbar;引用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k4g669.html">postman进行http接口测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gey1l08.html">●POJ 2983 Is the Information Reliable&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljz0p09.html">spring  IOC 分析及实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwjdjy8.html">matlab简介 基本操作</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1rgyr58.html">使用EF CodeFirst连接MySql数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd06ye9.html">使用Ajax的Time实现倒计时功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd04w09.html">&lbrack;日常&rsqb; Go语言圣经--并发的循环习题</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rwl0j9.html">Retrofit 2&period;0 使用和原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy5xw39.html">漫画 &vert; Java多线程与并发（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw61oj9.html">js formData图片上传（单图上传、多图上传）后台java</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw16678.html">Bootstrap&plus;PHP实现多图上传</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv7y6l8.html">jQuery复选框全选和全选取消</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rwx749.html">CSS文字超出指定长度，用省略号</a>
			</li>
						<li><a href="https://www.batexi.com/a/q257433q.html">JSTL核心标签库&mdash;&mdash;错误处理标签</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
